# Hydrozincite
---
Zn₅(CO₃)₂(OH)₆



![](typhlo.png) <!-- .element: width="" -->

## HS-157
---

* <!-- .element: class="fragment" --> GNU/Linux
* <!-- .element: class="fragment" --> Culture japonaise
* <!-- .element: class="fragment" --> Jeux vidéos
* <!-- .element: class="fragment" --> Speedrun



## Hydrozincite ?
---
Zn₅(CO₃)₂(OH)₆


## Générateur de page statique
---

![](screen1.png)


## Pourquoi ?

* Simple
* Static
* Projet


## Ce qui existe ?

* Gitlab
* Gitea / Gogs
* Gitweb
* Stagit



## Fonctionnalité

* <!-- .element: class="fragment" --> Générer une page
* <!-- .element: class="fragment" --> Info dépôt
* <!-- .element: class="fragment" --> Readme
* <!-- .element: class="fragment" --> Branches
* <!-- .element: class="fragment" --> Tarball
* <!-- .element: class="fragment" --> Git clone


## Qu'est-ce qu'il y a dedans ?

* <!-- .element: class="fragment" --> Python
* <!-- .element: class="fragment" --> Git
* <!-- .element: class="fragment" --> Gitpython
* <!-- .element: class="fragment" --> Jinja


## Python

* <!-- .element: class="fragment" --> Argparse
* <!-- .element: class="fragment" --> Configparser
* <!-- .element: class="fragment" --> Pathlib
* <!-- .element: class="fragment" --> Logging


## Et les tests ?

* <!-- .element: class="fragment" -->  Nox
* <!-- .element: class="fragment" -->  Pylama


## Comment l'utiliser ?

* <!-- .element: class="fragment" --> Dépendances
* <!-- .element: class="fragment" --> Dépôts bare
* <!-- .element: class="fragment" --> Fichier de configuration

<div class="fragment" />

~~~
[default]
title=Le distribil de HS-157
dir_bare=/srv/git/public
url_http_clone=https://bare.git.lett.re
output_dir=/srv/http/git.lett.re
template_dir=~/hydrozincite/templates
~~~


Exécution

---

~~~bash
> python hydrozincite/src 
2020-11-17 02:31:33,368 - INFO - Get info repo : NPD
2020-11-17 02:31:33,391 - INFO - Get info repo : Test
2020-11-17 02:31:33,415 - INFO - Get info repo : wiki.lett.re
2020-11-17 02:31:33,440 - INFO - Get info repo : Ansible-perso
2020-11-17 02:31:33,466 - INFO - Get info repo : MoeMoeKyun
2020-11-17 02:31:33,466 - INFO - Write all tarball
2020-11-17 02:31:33,475 - INFO - > Write tarball : /srv/http/git.lett.re/npd.tar.gz
2020-11-17 02:31:33,537 - INFO - > Write tarball : /srv/http/git.lett.re/test.tar.gz
2020-11-17 02:31:33,560 - INFO - > Write tarball : /srv/http/git.lett.re/wiki.lett.re.tar.gz
2020-11-17 02:31:33,588 - INFO - > Write tarball : /srv/http/git.lett.re/ansible-perso.tar.gz
2020-11-17 02:31:33,615 - INFO - > Write tarball : /srv/http/git.lett.re/moemoekyun.tar.gz
2020-11-17 02:31:33,718 - INFO - Render HTML page
2020-11-17 02:31:33,745 - INFO - Write HTML page
~~~


Intégration continue

---

<div class="fragment" />

post-update
~~~
#!/bin/sh
exec git update-server-info
~~~

<div class="fragment" />

post-receive
~~~
#!/bin/sh
echo "=============================="
echo "Repo : $(cat $(pwd)/name)"
python ~/hydrozincite/src --hook "$(pwd)"
echo "=============================="
~~~


~~~bash
Énumération des objets: 5, fait.
Décompte des objets: 100% (5/5), fait.
Écriture des objets: 100% (3/3), 256 octets | 256.00 Kio/s, fait.
Total 3 (delta 0), réutilisés 0 (delta 0), réutilisés du pack 0
remote: ==============================
remote: Repo : Test
remote: 2020-11-17 02:41:13,392 - INFO - Hook for : /srv/git/public/test.git
remote: 2020-11-17 02:41:13,418 - INFO - Get info repo : Test
remote: 2020-11-17 02:41:13,428 - INFO - > Write tarball : /srv/http/git.lett.re/test.tar.gz
remote: 2020-11-17 02:41:13,440 - INFO - Render HTML page
remote: 2020-11-17 02:41:13,456 - INFO - Write HTML page
remote: ==============================
To taiyo.hs-157.moe:/srv/git/public/test.git/
   075bc64..2d1524b  master -> master
~~~


## Démonstration
---


## Futur ?

* <!-- .element: class="fragment" --> Infos
 * <!-- .element: class="fragment" --> Contribution
 * <!-- .element: class="fragment" --> Licence
* <!-- .element: class="fragment" --> Tests
* <!-- .element: class="fragment" --> Sous-dossiers
* <!-- .element: class="fragment" --> Différents thèmes
* <!-- .element: class="fragment" --> Paquet
* <!-- .element: class="fragment" --> Logo ?
* <!-- .element: class="fragment" --> Mercurial ?


## Mais comment y contribuer à ton truc ?

<div class="fragment" />

* Via la forge

<div class="fragment" />

* Par courriel

~~~
git clone https://lab.shelter.moe/HS-157/hydrozincite
cd hydrozincite
git branche <feature> && git switch <feature>
<modification>
git commit
git bundle create <name>.bundle <commit_id1>..<commit_id2>
~~~



---
#### Liens
* [lab.shelter.moe/HS-157/hydrozincite](https://lab.shelter.moe/HS-157/hydrozincite)
* [git.lett.re](https://git.lett.re/)
---

---
#### Contact
* _IRC_ - HS-157 (freenode)
* _Courriel_ - hs-157@lett.re
* _Twitter_ - [HS\_157](https://twitter.com/HS_157)
---
